Draft Upgrade/es: Difference between revisions

From FreeCAD Documentation
(Created page with "==Opciones==")
(Updating to match new version of source page)
(14 intermediate revisions by 3 users not shown)
Line 1: Line 1:
<languages/>
{{GuiCommand/es|Name=Draft Upgrade|Workbenches=[[Draft Module/es|Croquis]], [[Arch Module/es|Arquitectura]]|MenuLocation=Croquis -> Promocionar|Shortcut=U P|Ver también=[[Draft Downgrade/es|Degradar]]}}
{{Docnav
|[[Draft_Split|Split]]
|[[Draft_Downgrade|Downgrade]]
|[[Draft_Module|Draft]]
|IconL=Draft_Split.svg
|IconC=Workbench_Draft.svg
|IconR=Draft_Downgrade.svg
}}

<div class="mw-translate-fuzzy">
{{GuiCommand/es|Name=Draft Upgrade|Workbenches=[[Draft Module/es|Croquis]], [[Arch Module/es|Arquitectura]]|MenuLocation=Croquis → Promocionar|Shortcut=U P|Ver también=[[Draft Downgrade/es|Degradar]]}}
</div>


==Descripción==
==Descripción==


<div class="mw-translate-fuzzy">
Esta herramienta promociona (convertir en un tipo de objeto más complejo) los objetos seleccionados de diversas formas. Si no se ha seleccionado ningún objeto, te invitará a seleccionar uno.
Esta herramienta promociona (convertir en un tipo de objeto más complejo) los objetos seleccionados de diversas formas. Si no se ha seleccionado ningún objeto, te invitará a seleccionar uno.
</div>

The Upgrade tool performs things such as creating faces and fusing different elements. This tool works with 2D Draft elements. To fuse 3D solids use [[Part Union]] and related Boolean operations of the [[Part Workbench]], and [[PartDesign Boolean]] of the [[PartDesign Workbench]].

The counterpart to this tool is the {{Button|[[Image:Draft Downgrade.svg|16px]] [[Draft Downgrade|Draft Downgrade]]}} operation.


[[Image:Draft_Upgrade_example.jpg|400px]]
[[Image:Draft_Upgrade_example.jpg|400px]]
{{Caption|Open wire upgraded to a closed wire, then to a face; a closed square upgraded to a face, and then fused with the previous face}}


==Utilización==
==Utilización==


<div class="mw-translate-fuzzy">
# Selecciona uno o más objetos que desees promocionar
# Selecciona uno o más objetos que desees promocionar
# Presiona el botón {{KEY|[[Image:Draft Upgrade.png|16px]] [[Draft Upgrade/es|Promocionar]]}} o presiona las teclas {{KEY|U}} y {{KEY|P}}
# Presiona el botón {{KEY|[[Image:Draft Upgrade.png|16px]] [[Draft Upgrade/es|Promocionar]]}} o presiona las teclas {{KEY|U}} y {{KEY|P}}
</div>

The selected objects are modified or upgraded according to the following conditions, in order:
# If there are more than one face in the selection, the faces are merged (union).
# If there is only one face in the selection, nothing is done.
# If there is only one open wire in the selection, it gets closed, making a face.
# If there are only edges in the selection, all edges are joined into a wire, and the wire is closed if possible.
# If none of the above is possible, a compound object is created.

It is worth trying to upgrade a selection several times to see if a better shape is obtained. For example:
# Upgrading two [[Draft Line]]s connected at one end will result in a non-editable wire.
# Upgrading this element again will add a third line and close the non-editable wire.
# Upgrading this element again will add a face to the closed, non-editable wire.
# Upgrading this element again will turn it into a [[Draft Wire]], which can be fully edited, and all its properties modified.

The resulting wire can be better manipulated than the original lines. The fusion of single lines can also be done directly with the [[Draft Wire]] tool. Some fusion operations can also be done with the [[Part Union|Part Union]] tool.


==Opciones==
==Opciones==


<div class="mw-translate-fuzzy">
The selected objects are modified/upgraded according to the following conditions (in order):
Los objetos seleccionados son modificados/promocionados de acuerdo con las siguientes condiciones (en orden):
* if there are more than one face in the selection, the faces are merged (union)
* Si hay más de una cara seleccionada, las caras se fusionan (unión)
* if there is only one face in the selection, nothing is done
* Si sólo hay una cara seleccionada, no hace nada
* if there is only one open wire in the selection, it gets closed
* Si sólo hay un contorno abierto seleccionado, lo cierra
* if there are only edges in the selection, all edges are joined into a wire (closed if possible)
* Si solo hay aristas seleccionadas, se juntan todas las aristas en un contorno o wire (cerrado si es posible)
* if none of the above is possible, a compound object is created
* Si ninguna de las opciones anteriores es posible, crea un objeto compuesto
</div>


<div class="mw-translate-fuzzy">
==Scripting==
==Programación==
</div>


The upgrade tool can be used from python scripts and [[macros]] like this:
The Upgrade tool can be used in [[macros]] and from the [[Python]] console by using the following function:


{{Code|code=
<syntaxhighlight>
Draft.upgrade(objects, delete=False, force=None)
upgrade_list = upgrade(objects, delete=False, force=None)
addList, deleteList = upgrade(objects, delete=False, force=None)
</syntaxhighlight>
}}


* Upgrades the given object(s) (can be an object or a list of objects).
* Upgrades the given {{incode|objects}}, which can be a single object or a list of objects.
* If delete is True, old objects are deleted.
* If {{incode|delete}} is {{incode|True}}, old objects are deleted.
* The force attribute can be used to force a certain way of upgrading. It can be: makeCompound, closeGroupWires, makeSolid, closeWire, turnToParts, makeFusion, makeShell, makeFaces, draftify, joinFaces, makeSketchFace, makeWires
* If {{incode|force}} is given, it is the internal function to call to force a certain way of upgrading. It can be: {{incode|"makeCompound"}}, {{incode|"closeGroupWires"}}, {{incode|"makeSolid"}}, {{incode|"closeWire"}}, {{incode|"turnToParts"}}, {{incode|"makeFusion"}}, {{incode|"makeShell"}}, {{incode|"makeFaces"}}, {{incode|"draftify"}}, {{incode|"joinFaces"}}, {{incode|"makeSketchFace"}}, {{incode|"makeWires"}}, or {{incode|"turnToLine"}}.
* Returns a dictionnary containing two lists, a list of new objects and a list of objects to be deleted
* {{incode|upgrade_list}} is returned, which is a list containing two lists: a list of new objects ({{incode|addList}}) and a list of objects to be deleted ({{incode|deleteList}}).


Ejemplo:
Some of the operations of the Upgrade tool can also be made with the [[Part Fuse]] or [[Draft Wire]] tools.


{{Code|code=
Example:
import FreeCAD, Draft


Circle = Draft.makeCircle(1000)
<syntaxhighlight>
Rectangle = Draft.makeRectangle(2000, 800)
import Draft
mycircle = Draft.makeCircle(2)
face1 = Draft.upgrade([mycircle],True)
</syntaxhighlight>


addList1, deleteList1 = Draft.upgrade([Circle, Rectangle], delete=False)
<languages/>
fused = addList1[0]

Line1 = Draft.makeLine(FreeCAD.Vector(2000, 0, 0), FreeCAD.Vector(2500, 1500, 0))
Line2 = Draft.makeLine(FreeCAD.Vector(2500, 1500, 0), FreeCAD.Vector(3000, -1000, 0))
addList2, deleteList2 = Draft.upgrade([Line1, Line2], delete=False)

simple_wire = addList2[0]
addList3, deleteList3 = Draft.upgrade(simple_wire, delete=False)

closed_wire = addList3[0]
addList4, deleteList4 = Draft.upgrade(closed_wire, delete=False)

face = addList4[0]
addList5, deleteList5 = Draft.upgrade(face, delete=False)
}}

{{Docnav
|[[Draft_Split|Split]]
|[[Draft_Downgrade|Downgrade]]
|[[Draft_Module|Draft]]
|IconL=Draft_Split.svg
|IconC=Workbench_Draft.svg
|IconR=Draft_Downgrade.svg
}}

{{Draft Tools navi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}
{{clear}}

Revision as of 04:34, 21 February 2020

Draft Upgrade

Ubicación en el Menú
Croquis → Promocionar
Entornos de trabajo
Croquis, Arquitectura
Atajo de teclado por defecto
U P
Introducido en versión
-
Ver también
Ninguno

Descripción

Esta herramienta promociona (convertir en un tipo de objeto más complejo) los objetos seleccionados de diversas formas. Si no se ha seleccionado ningún objeto, te invitará a seleccionar uno.

The Upgrade tool performs things such as creating faces and fusing different elements. This tool works with 2D Draft elements. To fuse 3D solids use Part Union and related Boolean operations of the Part Workbench, and PartDesign Boolean of the PartDesign Workbench.

The counterpart to this tool is the Draft Downgrade operation.

Open wire upgraded to a closed wire, then to a face; a closed square upgraded to a face, and then fused with the previous face

Utilización

  1. Selecciona uno o más objetos que desees promocionar
  2. Presiona el botón Promocionar o presiona las teclas U y P

The selected objects are modified or upgraded according to the following conditions, in order:

  1. If there are more than one face in the selection, the faces are merged (union).
  2. If there is only one face in the selection, nothing is done.
  3. If there is only one open wire in the selection, it gets closed, making a face.
  4. If there are only edges in the selection, all edges are joined into a wire, and the wire is closed if possible.
  5. If none of the above is possible, a compound object is created.

It is worth trying to upgrade a selection several times to see if a better shape is obtained. For example:

  1. Upgrading two Draft Lines connected at one end will result in a non-editable wire.
  2. Upgrading this element again will add a third line and close the non-editable wire.
  3. Upgrading this element again will add a face to the closed, non-editable wire.
  4. Upgrading this element again will turn it into a Draft Wire, which can be fully edited, and all its properties modified.

The resulting wire can be better manipulated than the original lines. The fusion of single lines can also be done directly with the Draft Wire tool. Some fusion operations can also be done with the Part Union tool.

Opciones

Los objetos seleccionados son modificados/promocionados de acuerdo con las siguientes condiciones (en orden):

  • Si hay más de una cara seleccionada, las caras se fusionan (unión)
  • Si sólo hay una cara seleccionada, no hace nada
  • Si sólo hay un contorno abierto seleccionado, lo cierra
  • Si solo hay aristas seleccionadas, se juntan todas las aristas en un contorno o wire (cerrado si es posible)
  • Si ninguna de las opciones anteriores es posible, crea un objeto compuesto

Programación

The Upgrade tool can be used in macros and from the Python console by using the following function:

upgrade_list = upgrade(objects, delete=False, force=None)
addList, deleteList = upgrade(objects, delete=False, force=None)
  • Upgrades the given objects, which can be a single object or a list of objects.
  • If delete is True, old objects are deleted.
  • If force is given, it is the internal function to call to force a certain way of upgrading. It can be: "makeCompound", "closeGroupWires", "makeSolid", "closeWire", "turnToParts", "makeFusion", "makeShell", "makeFaces", "draftify", "joinFaces", "makeSketchFace", "makeWires", or "turnToLine".
  • upgrade_list is returned, which is a list containing two lists: a list of new objects (addList) and a list of objects to be deleted (deleteList).

Ejemplo:

import FreeCAD, Draft

Circle = Draft.makeCircle(1000)
Rectangle = Draft.makeRectangle(2000, 800)

addList1, deleteList1 = Draft.upgrade([Circle, Rectangle], delete=False)
fused = addList1[0]

Line1 = Draft.makeLine(FreeCAD.Vector(2000, 0, 0), FreeCAD.Vector(2500, 1500, 0))
Line2 = Draft.makeLine(FreeCAD.Vector(2500, 1500, 0), FreeCAD.Vector(3000, -1000, 0))
addList2, deleteList2 = Draft.upgrade([Line1, Line2], delete=False)

simple_wire = addList2[0]
addList3, deleteList3 = Draft.upgrade(simple_wire, delete=False)

closed_wire = addList3[0]
addList4, deleteList4 = Draft.upgrade(closed_wire, delete=False)

face = addList4[0]
addList5, deleteList5 = Draft.upgrade(face, delete=False)